﻿Imports Infragistics
Imports Infragistics.Win
Imports Infragistics.Win.UltraWinGrid
Imports System.Reflection

Public Class Form1
    Public iRowCnt As Integer = 0
    Public strRowExp As New ArrayList
    Private bColorFlag As Boolean

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Debug.Print("#######")
        ' Get a DataTable instance from helper function.
        Dim table As DataTable = GetTable()
        UltraGrid1.DataSource = table
        'Net Advantage Select UltraGrid
        'Version 9.1.20091.1000 

    End Sub

    ''' <summary>
    ''' Helper function that creates new DataTable.
    ''' </summary>
    Function GetTable() As DataTable
        ' Create new DataTable instance.
        Dim table As New DataTable
        ' Create four typed columns in the DataTable.
        table.Columns.Add("Dosage", GetType(Integer))
        table.Columns.Add("Drug", GetType(String))
        table.Columns.Add("Patient", GetType(String))
        table.Columns.Add("Date", GetType(DateTime))
        ' Add five rows with those columns filled in the DataTable.
        table.Rows.Add(25, "Indocin", "David", DateTime.Now)
        table.Rows.Add(50, "Enebrel", "Sam", DateAdd(DateInterval.Day, -1, DateTime.Now))
        table.Rows.Add(10, "Hydralazine", "Christoff", DateTime.Now)
        table.Rows.Add(21, "Combivent", "Janet", DateAdd(DateInterval.Day, -1, DateTime.Now))
        table.Rows.Add(100, "Dilantin", "Melanie", DateTime.Now)
        table.Rows.Add(25, "Indocin", "Kim", DateAdd(DateInterval.Day, -1, DateTime.Now))
        table.Rows.Add(50, "Enebrel", "Vin", DateTime.Now)
        table.Rows.Add(10, "Hydralazine", "Chris", DateAdd(DateInterval.Day, -2, DateTime.Now))
        table.Rows.Add(21, "Combivent", "Kristin", DateTime.Now)
        table.Rows.Add(100, "Dilantin", "Mike", DateAdd(DateInterval.Day, -2, DateTime.Now))
        table.Rows.Add(25, "Indocin", "Anna", DateTime.Now)
        table.Rows.Add(50, "Enebrel", "Louis", DateAdd(DateInterval.Day, -2, DateTime.Now))
        table.Rows.Add(10, "Hydralazine", "Steve", DateTime.Now)
        table.Rows.Add(21, "Combivent", "Reg", DateTime.Now)
        table.Rows.Add(100, "Dilantin", "Tom", DateTime.Now)
        '
        table.Rows.Add(50, "Indocin", "David", DateTime.Now)
        table.Rows.Add(75, "Enebrel", "Sam", DateAdd(DateInterval.Day, -1, DateTime.Now))
        table.Rows.Add(21, "Hydralazine", "Christoff", DateTime.Now)
        table.Rows.Add(35, "Combivent", "Janet", DateAdd(DateInterval.Day, -1, DateTime.Now))
        table.Rows.Add(50, "Dilantin", "Melanie", DateTime.Now)
        table.Rows.Add(50, "Indocin", "Kim", DateAdd(DateInterval.Day, -1, DateTime.Now))
        table.Rows.Add(25, "Enebrel", "Vin", DateTime.Now)
        table.Rows.Add(35, "Hydralazine", "Chris", DateAdd(DateInterval.Day, -2, DateTime.Now))
        table.Rows.Add(50, "Combivent", "Kristin", DateTime.Now)
        table.Rows.Add(75, "Dilantin", "Mike", DateAdd(DateInterval.Day, -2, DateTime.Now))
        table.Rows.Add(10, "Indocin", "Anna", DateTime.Now)
        table.Rows.Add(21, "Enebrel", "Louis", DateAdd(DateInterval.Day, -2, DateTime.Now))
        table.Rows.Add(25, "Hydralazine", "Steve", DateTime.Now)
        table.Rows.Add(50, "Combivent", "Reg", DateTime.Now)
        table.Rows.Add(10, "Dilantin", "Tom", DateTime.Now)
        Return table
    End Function

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        UltraGrid1.Rows.Refresh(RefreshRow.FireInitializeRow, True)
    End Sub
    Private Sub initGroupBy(ByVal Sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeRowEventArgs) Handles UltraGrid1.InitializeRow
        Debug.Print("InitializeRow")
        Dim strStatus As String
        Dim _strMethodName As String = System.Reflection.MethodBase.GetCurrentMethod().Name

        If CheckBox1.Checked = True Then
            'Debug.Print("C=============")
            'Debug.Print("VisibleIndex " & e.Row.VisibleIndex)
            'Debug.Print("Bandindex " & e.Row.Band.Index)
            'Debug.Print("ListIndex: " & e.Row.ListIndex)
            strStatus = e.Row.Cells("Drug").Value.ToString
            Select Case strStatus
                Case "Hydralazine"
                    e.Row.Appearance.BackColor = Color.PowderBlue 'FromArgb(255, 85, 85)
                Case "Indocin"
                    e.Row.Appearance.BackColor = Color.Pink 'FromArgb(255, 128, 128) '85, 85)
                Case "Enebrel"
                    e.Row.Appearance.BackColor = Color.Purple 'FromArgb(255, 192, 128)
                Case "Combivent"
                    e.Row.Appearance.BackColor = Color.Orange 'FromArgb(255, 85, 85)
                Case "Dilantin"
                    e.Row.Appearance.BackColor = Color.PaleGreen 'FromArgb(255, 128, 128) '85, 85)

            End Select
        Else
            'Debug.Print("NC=============")
            'Debug.Print("VisibleIndex " & e.Row.VisibleIndex)
            'Debug.Print("Bandindex " & e.Row.Band.Index)
            'Debug.Print("ListIndex: " & e.Row.ListIndex)
            'If e.Row.VisibleIndex Mod 2 = 0 Then
            '    e.Row.Appearance.BackColor = Color.Gainsboro
            'Else
            '    e.Row.Appearance.BackColor = Color.White
            'End If

            bColorFlag = Not (bColorFlag)
            If bColorFlag = True Then
                e.Row.Appearance.BackColor = Color.Gainsboro
            Else
                e.Row.Appearance.BackColor = Color.White
            End If

        End If
    End Sub
    Private Sub initGroupByRow(ByVal Sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeGroupByRowEventArgs) Handles UltraGrid1.InitializeGroupByRow
        Debug.Print("InitializeGroupByRow")
        'For Each item In strRowExp
        '    UltraGrid1.Rows(0).Expanded(True)
        '    UltraGrid1.
        'Next
        'Debug.Print("Sender Name " & CType(Sender, UltraGrid).Name)
        Dim iLoc As Integer
        Dim strDescription As String
        iLoc = InStr(e.Row.Description, "(")
        strDescription = Mid(e.Row.Description, 1, iLoc - 1)
        For Each item As String In strRowExp
            'this is the spot to mid the description
            iLoc = InStr(item, "(")
            If Mid(item, 1, iLoc - 1) = strDescription Then
                'If strRowExp.Contains(Mid(e.Row.Description, 1, iLoc)) Then
                e.Row.Expanded = True
            End If
        Next

        'If strRowExp.Contains(e.Row.VisibleIndex) Then
        '    e.Row.Expanded = True
        'End If

    End Sub

    Private Sub AfterRowCollapsed(ByVal Sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.RowEventArgs) Handles UltraGrid1.AfterRowCollapsed
        Debug.Print("AfterRowCollapsed")
    End Sub
    Private Sub AfterGroupPosChanged(ByVal Sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.AfterGroupPosChangedEventArgs) Handles UltraGrid1.AfterGroupPosChanged
        Debug.Print("AfterGroupPosChanged")
    End Sub
    Private Sub AfterPerformAction(ByVal Sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.AfterUltraGridPerformActionEventArgs) Handles UltraGrid1.AfterPerformAction
        Debug.Print("AfterPerformAction")
    End Sub
    Private Sub AfterHeaderCheckStateChanged(ByVal Sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.AfterHeaderCheckStateChangedEventArgs) Handles UltraGrid1.AfterHeaderCheckStateChanged
        Debug.Print("AfterHeaderCheckStateChanged")
    End Sub
    Private Sub AfterRowActivate(ByVal Sender As Object, ByVal e As System.EventArgs) Handles UltraGrid1.AfterRowActivate
        Debug.Print("AfterRowActivate")
        Debug.Print("----------------")
        'If CheckBox1.Checked = False Then
        '    UltraGrid1.Rows.Refresh(RefreshRow.FireInitializeRow, True)
        'End If
        '    Debug.Print("xyz")
        '    Dim strStatus As String
        '    Dim _strMethodName As String = System.Reflection.MethodBase.GetCurrentMethod().Name

        '    Dim iRow As Integer = 1
        '    If CheckBox1.Checked = False Then
        '        For Each ugRow As UltraGridRow In CType(Sender, UltraGrid).Rows 'can be either ugCollections.AfterSortChange, ugPaid.AfterSortChange
        '            If iRow Mod 2 = 0 Then
        '                ugRow.Appearance.BackColor = Color.Gainsboro
        '            Else
        '                ugRow.Appearance.BackColor = Color.White
        '            End If
        '            iRow = iRow + 1
        '        Next

        '    End If

    End Sub

    Private Sub InitializeRowsCollection(ByVal Sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeRowsCollectionEventArgs) Handles UltraGrid1.InitializeRowsCollection

        Debug.Print("InitializeRowsCollection")
        'Dim strStatus As String
        'Dim _strMethodName As String = System.Reflection.MethodBase.GetCurrentMethod().Name

        'Dim iRow As Integer = 1
        'If CheckBox1.Checked = False Then
        '    For Each ugRow As UltraGridRow In CType(Sender, UltraGrid).Rows 'can be either ugCollections.AfterSortChange, ugPaid.AfterSortChange
        '        If iRow Mod 2 = 0 Then
        '            ugRow.Appearance.BackColor = Color.Gainsboro
        '        Else
        '            ugRow.Appearance.BackColor = Color.White
        '        End If
        '        iRow = iRow + 1
        '    Next

        'End If

    End Sub


    Private Sub AftersortChange(ByVal Sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.BandEventArgs) Handles UltraGrid1.AfterSortChange
        Debug.Print("AftersortChange")
        If CheckBox1.Checked = False Then
            UltraGrid1.Rows.Refresh(RefreshRow.FireInitializeRow, True)
        End If
        'Dim strStatus As String
        'Dim _strMethodName As String = System.Reflection.MethodBase.GetCurrentMethod().Name

        'Dim iRow As Integer = 1
        'If CheckBox1.Checked = False Then
        '    For Each ugRow As UltraGridRow In CType(Sender, UltraGrid).Rows 'can be either ugCollections.AfterSortChange, ugPaid.AfterSortChange
        '        If ugRow.VisibleIndex Mod 2 = 0 Then
        '            ugRow.Appearance.BackColor = Color.Gainsboro
        '        Else
        '            ugRow.Appearance.BackColor = Color.White
        '        End If
        '        iRow = iRow + 1
        '    Next

        'End If

    End Sub



    Private Sub btnReload_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReload.Click
        strRowExp.Clear()
        For Each ugRow As UltraGridRow In UltraGrid1.Rows
            IsItGroupBy(ugRow)
            'If ugRow.IsGroupByRow Then
            '    If ugRow.IsExpanded Then
            '        strRowExp.Add(ugRow.VisibleIndex)

            '    End If
            'End If
        Next

        Dim table As DataTable = GetTable()
        UltraGrid1.DataSource = table

        'UltraGrid1.Rows.Refresh(RefreshRow.FireInitializeRow, True)

        'For Each item In strRowExp
        '    UltraGrid1.Rows(item).Expanded = True
        'Next
    End Sub
    Private Sub IsItGroupBy(ByVal ugRow As UltraGridRow)
        If ugRow.IsGroupByRow Then
            If ugRow.IsExpanded Then
                'strRowExp.Add(ugRow.VisibleIndex)'Does not work since calling the refreash from a different tab then the grid it on
                strRowExp.Add(ugRow.Description)
                If ugRow.HasChild Then
                    For Each ugChildRow As UltraGridRow In ugRow.ChildBands(0).Rows
                        IsItGroupBy(ugChildRow) 'Recursive call to handle multiple nestings
                    Next
                End If
            End If
        End If
    End Sub


    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'Dim props As PropertyInfo() = GetType(Color).GetProperties(BindingFlags.[Static] Or BindingFlags.[Public])

        'For Each prop As PropertyInfo In props
        '    Dim o As Object = prop.GetValue(Nothing, Nothing)
        '    If o IsNot Nothing Then
        '        textbox1.Text = Textbox1.text + Constants.vbCrLf + prop.Name + " - " + o.ToString()
        '    End If
        'Next

        'Dim myType As Type = GetType(Button)
        'Dim properties As System.Reflection.PropertyInfo() = myType.GetProperties()

        'For Each p As System.Reflection.PropertyInfo In properties
        '    'Dim o As Object = p.GetValue(Nothing, Nothin)

        '    Debug.Print(p.Name & " - " & p.GetValue(Nothing, Nothing))
        'Next

        ''''''''''''''''''''''''''''''''''''
        'Debug.Print("=====================")
        'Dim theObject As New Button()
        'Dim propertyList As PropertyInfo() = theObject.[GetType]().GetProperties()
        'For Each item As PropertyInfo In propertyList
        '    'MessageBox.Show(item.Name + "(" & item.[GetType]().ToString() & ")" & " : " & item.GetValue(theObject, Nothing).ToString())
        '    'Debug.Print(item.Name + "(" & item.[GetType]().ToString() & ")" & " : " & item.GetValue(theObject, Nothing).ToString())
        '    Dim o As Object = item.GetValue(theObject, Nothing)
        '    TextBox1.Text = TextBox1.Text + Constants.vbCrLf + item.Name + "(" & item.[GetType]().ToString() & ")" & " : " ' & item.GetValue(theObject, Nothing).ToString()
        '    If o IsNot Nothing Then
        '        TextBox1.Text = TextBox1.Text + o.ToString()
        '    End If
        'Next


        'Debug.Print("=====================")
        ''Dim theObject As New Button()
        'Dim propertyList As PropertyInfo() = Button1.[GetType]().GetProperties()
        'For Each item As PropertyInfo In propertyList
        '    'MessageBox.Show(item.Name + "(" & item.[GetType]().ToString() & ")" & " : " & item.GetValue(theObject, Nothing).ToString())
        '    'Debug.Print(item.Name + "(" & item.[GetType]().ToString() & ")" & " : " & item.GetValue(theObject, Nothing).ToString())
        '    Dim o As Object = item.GetValue(Button1, Nothing)
        '    TextBox1.Text = TextBox1.Text + Constants.vbCrLf + item.Name + "(" & item.[GetType]().ToString() & ")" & " : " ' & item.GetValue(theObject, Nothing).ToString()
        '    If o IsNot Nothing Then
        '        TextBox1.Text = TextBox1.Text + o.ToString() + ","
        '    Else
        '        TextBox1.Text = TextBox1.Text + ","
        '    End If
        'Next

    End Sub

End Class
